/* dsa.c - DSA verification
 *	Copyright (C) 1999 Werner Koch (dd9jn).
 *
 * This file is part of SFSV.
 *
 * SFSV is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SFSV is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#if defined(__UBOOT_BUILD__)
#include <config.h> //secure/not secure for U-boot build
#include <malloc.h>
#endif

#include "gpgconfig.h"
#ifndef __KERNEL__
#include <stdio.h>
#include <string.h>
#endif
#include "types.h"
#include "bigint.h"
#include "dsa.h"
#include "gpg-v3-verify.h"


typedef struct {
    BIGINT p;	    /* prime */
    BIGINT q;	    /* prime factor of p-1 (160 bits) */
    BIGINT g;	    /* generator */
    BIGINT y;	    /* g^x mod p */
} PUBLIC_KEY;

typedef struct {
	u32 keyid[2];
	const char *p, *q, *g, *y;
} KEY_TABLE_ENTRY;

/*******************************************/
/*          	 |  Secure  |   Not secure */
/*   Uboot  	 |    P     |      S       */
/*   PBL    	 |    P     |      P       */
/*   Applet 	 |    P     |      P       */
/*   Application |    P/S2  |      P/S2    */
/*******************************************/
/*   S - server      keys_inner.h          */
/*   S2 - server     keys.h                */
/*   P - local file with public keys       */
/*******************************************/

#if defined(__UBOOT_BUILD__)
#if defined(__STB_SECURE__) 
#	define __KEYTABLE_PUBLIC__
# 	include "keys_public.h" /* local file generated by makekeys */
#else
#	define __KEYTABLE_SERVER__
#	include "keys_inner.h" /* file generated by integration bootloader make */
#endif
#endif /*__UBOOT_BUILD__*/

#if defined(__PBL_BUILD__) || defined(__APPLET_BUILD__)
#	define __KEYTABLE_PUBLIC__
# 	include "keys_public.h" 	/* local file generated by makekeys */
#endif /* __PBL_BUILD__ || __APPLET_BUILD__ */

#if defined(__APPLICATION_BUILD__)
#	define __KEYTABLE_PUBLIC__
#	define __KEYTABLE_SERVER__
# 	include "keys.h" 			/* file generated by makekeys */
# 	include "keys_public.h" 	/* local file generated by makekeys */
#endif /* __APPLICATION_BUILD__ */

/****************
 * Returns true if the signature composed from R and S is valid.
 * m is the encoded hash value
 */
static int
verify( PUBLIC_KEY *pk, BIGINT *m, BIGINT *r, BIGINT *s )
{
    BIGINT zero;
    BIGINT tmp, w, u1, u2, v;
    BIGINT *base[2];
    BIGINT *exp[2];

    bi_init( &zero, 0 ),
    bi_init( &w,  bi_nlimbs(&pk->q) );
    bi_init( &u1, bi_nlimbs(&pk->q) );
    bi_init( &u2, bi_nlimbs(&pk->q) );
    bi_init( &v,  bi_nlimbs(&pk->p) );
    bi_init( &tmp,  bi_nlimbs(&pk->p) );

    /* check that R is less than Q */
    if( bi_cmp( r, &zero ) <= 0 || bi_cmp( r, &pk->q ) >= 0 )
	return 0;
    /* check that S is less than Q */
    if( bi_cmp( s, &zero ) <= 0 || bi_cmp( s, &pk->q ) >= 0 )
	return 0;

    /* w = s^(-1) mod q */
    bi_invm( &w, s, &pk->q );

    /* u1 = (m * w) mod q */
    bi_mulm( &u1, m, &w, &pk->q );

    /* u2 = r * w mod q  */
    bi_mulm( &u2, r, &w, &pk->q );

    /* v =  g^u1 * y^u2 mod p mod q */
    base[0] = &pk->g; exp[0] = &u1;
    base[1] = &pk->y; exp[1] = &u2;
    bi_mulexpm( &tmp, base, exp, 2, &pk->p );
    bi_mod( &v, &tmp, &pk->q );

    return !bi_cmp( &v, r );
}

/* =============================================================================================================
 * 1) Find the Public Key
 * 2) Decrypt the Signature using the Public Key
 * 3) Check the hash value stored in the decrypted Signature against the hash value of the encrypted initramfs image
   ============================================================================================================*/
int
verify_signature( const unsigned char *hash, u32 hash_size_bits, SIG_packet *sig )
{
    PUBLIC_KEY pk;
    KEY_TABLE_ENTRY *keytable_ptr;
    BIGINT m;
    /* reserve space until 512bit hash */
    byte tmpbuf[66];
    int i;

    /* depending on target (see table above) we need to
     * search through local table, server table or both */

    /* query local keytable*/
	#ifdef __KEYTABLE_PUBLIC__
    keytable_ptr = keytable_local;
    //LOGERROR("v1.1 search local keytable for 0x%x,0x%x",sig->keyid[0],sig->keyid[1]);
    for(i=0; keytable_ptr[i].p ; i++ ) {
    //LOGERROR("0x%x,0x%x",keytable_ptr[i].keyid[0],keytable_ptr[i].keyid[1]);
	if( keytable_ptr[i].keyid[0] == sig->keyid[0]
	    && keytable_ptr[i].keyid[1] == sig->keyid[1] )
	    goto key_found;
    }
	#endif

    /* query server keytable*/
	#ifdef __KEYTABLE_SERVER__
    keytable_ptr = (KEY_TABLE_ENTRY *) keytable ;
    //LOGERROR("search server keytable for 0x%x,0x%x",sig->keyid[0],sig->keyid[1]);
    for(i=0; keytable_ptr[i].p ; i++ ) {
    //LOGERROR("0x%x,0x%x",keytable_ptr[i].keyid[0],keytable_ptr[i].keyid[1]);
	if( keytable_ptr[i].keyid[0] == sig->keyid[0]
	    && keytable_ptr[i].keyid[1] == sig->keyid[1] )
		goto key_found;
    }
	#endif

key_found:
    if( !keytable_ptr[i].p )
	return SFSV_NO_KEY;

    bi_init( &pk.p, 0 );
    bi_init( &pk.q, 0 );
    bi_init( &pk.g, 0 );
    bi_init( &pk.y, 0 );
    bi_scan( &pk.p, keytable_ptr[i].p );
    bi_scan( &pk.q, keytable_ptr[i].q );
    bi_scan( &pk.g, keytable_ptr[i].g );
    bi_scan( &pk.y, keytable_ptr[i].y );

    /* encode the hash */
    tmpbuf[0] = (byte)((hash_size_bits >> 8) & 0xff);
    tmpbuf[1] = (byte)(hash_size_bits & 0xff);
    memcpy( tmpbuf+2, hash, (hash_size_bits / 8) );
    bi_read( &m, (const char *) tmpbuf, ((hash_size_bits / 8) + 2) );
    /* and verify */
    return verify( &pk, &m, &sig->r, &sig->s )? 0 : SFSV_BAD_SIG;
}
